VTK: vtkSSAOPass Class Reference

| VTK 9.3.1

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
vtkSSAOPass Class Reference

Implement a screen-space ambient occlusion pass. More...

`#include <vtkSSAOPass.h>`

Inheritance diagram for vtkSSAOPass:
[legend]
Collaboration diagram for vtkSSAOPass:
[legend]

## Public Types
typedef vtkImageProcessingPass | Superclass
Public Types inherited from vtkImageProcessingPass
typedef vtkOpenGLRenderPass | Superclass
Public Types inherited from vtkOpenGLRenderPass
typedef vtkRenderPass | Superclass
Public Types inherited from vtkRenderPass
typedef vtkObject | Superclass

## Public Member Functions
virtual vtkTypeBool | IsA (const char *type)
| Return 1 if this class is the same type of (or a subclass of) the named class. More...
vtkSSAOPass * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
void | Render (const vtkRenderState *s) override
| Perform rendering according to a render state. More...
void | ReleaseGraphicsResources (vtkWindow *w) override
| Release graphics resources and ask components to release their own resources. More...
bool | PreReplaceShaderValues (std::string &vertexShader, std::string &geometryShader, std::string &fragmentShader, vtkAbstractMapper *mapper, vtkProp *prop) override
| Pre replace shader values. More...
bool | PostReplaceShaderValues (std::string &vertexShader, std::string &geometryShader, std::string &fragmentShader, vtkAbstractMapper *mapper, vtkProp *prop) override
| Post replace shader values. More...
bool | SetShaderParameters (vtkShaderProgram *program, vtkAbstractMapper *mapper, vtkProp *prop, vtkOpenGLVertexArrayObject *VAO=nullptr) override
| Set shader parameters. More...
virtual double | GetRadius ()
| Get/Set the SSAO hemisphere radius. More...
virtual void | SetRadius (double)
| Get/Set the SSAO hemisphere radius. More...
virtual unsigned int | GetKernelSize ()
| Get/Set the number of samples. More...
virtual void | SetKernelSize (unsigned int)
| Get/Set the number of samples. More...
virtual double | GetBias ()
| Get/Set the bias when comparing samples. More...
virtual void | SetBias (double)
| Get/Set the bias when comparing samples. More...
virtual bool | GetBlur ()
| Get/Set blurring of the ambient occlusion. More...
virtual void | SetBlur (bool)
| Get/Set blurring of the ambient occlusion. More...
virtual void | BlurOn ()
| Get/Set blurring of the ambient occlusion. More...
virtual void | BlurOff ()
| Get/Set blurring of the ambient occlusion. More...
Public Member Functions inherited from vtkImageProcessingPass
vtkImageProcessingPass * | NewInstance () const
virtual vtkRenderPass * | GetDelegatePass ()
| Delegate for rendering the image to be processed. More...
virtual void | SetDelegatePass (vtkRenderPass *delegatePass)
| Delegate for rendering the image to be processed. More...
Public Member Functions inherited from vtkOpenGLRenderPass
vtkOpenGLRenderPass * | NewInstance () const
virtual vtkMTimeType | GetShaderStageMTime ()
| For multi-stage render passes that need to change shader code during a single pass, use this method to notify a mapper that the shader needs to be rebuilt (rather than reuse the last cached shader. More...
virtual void | SetActiveDrawBuffers (unsigned int)
| Number of active draw buffers. More...
virtual unsigned int | GetActiveDrawBuffers ()
Public Member Functions inherited from vtkRenderPass
vtkRenderPass * | NewInstance () const
virtual int | GetNumberOfRenderedProps ()
| Number of props rendered at the last Render call. More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
virtual vtkMTimeType | GetMTime ()
| Return this object's modified time. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual bool | UsesGarbageCollector () const
| Indicate whether the class uses `vtkGarbageCollector` or not. More...

## Static Public Member Functions
static vtkSSAOPass * | New ()
static vtkTypeBool | IsTypeOf (const char *type)
static vtkSSAOPass * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkImageProcessingPass
static vtkTypeBool | IsTypeOf (const char *type)
static vtkImageProcessingPass * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkOpenGLRenderPass
static vtkTypeBool | IsTypeOf (const char *type)
static vtkOpenGLRenderPass * | SafeDownCast (vtkObjectBase *o)
static vtkInformationObjectBaseVectorKey * | RenderPasses ()
| Key containing information about the current pass. More...
Static Public Member Functions inherited from vtkRenderPass
static vtkTypeBool | IsTypeOf (const char *type)
static vtkRenderPass * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...

## Protected Member Functions
virtual vtkObjectBase * | NewInstanceInternal () const
| vtkSSAOPass ()=default
| ~vtkSSAOPass () override=default
void | ComputeKernel ()
void | InitializeGraphicsResources (vtkOpenGLRenderWindow *renWin, int w, int h)
void | RenderDelegate (const vtkRenderState *s, int w, int h)
void | RenderSSAO (vtkOpenGLRenderWindow *renWin, vtkMatrix4x4 *projection, int w, int h)
void | RenderCombine (vtkOpenGLRenderWindow *renWin)
Protected Member Functions inherited from vtkImageProcessingPass
| vtkImageProcessingPass ()
| Default constructor. More...
| ~vtkImageProcessingPass () override
| Destructor. More...
void | RenderDelegate (const vtkRenderState *s, int width, int height, int newWidth, int newHeight, vtkOpenGLFramebufferObject *fbo, vtkTextureObject *target)
| Render delegate with a image of different dimensions than the original one. More...
Protected Member Functions inherited from vtkOpenGLRenderPass
| vtkOpenGLRenderPass ()
| ~vtkOpenGLRenderPass () override
void | PreRender (const vtkRenderState *s)
| Call before rendering to update the actors' information keys. More...
void | PostRender (const vtkRenderState *s)
| Call after rendering to clean up the actors' information keys. More...
Protected Member Functions inherited from vtkRenderPass
| vtkRenderPass ()
| Default constructor. More...
| ~vtkRenderPass () override
| Destructor. More...
void | UpdateCamera (vtkRenderer *renderer)
| Call UpdateCamera() on Renderer. More...
void | ClearLights (vtkRenderer *renderer)
| Call ClearLights() on Renderer. More...
void | UpdateLightGeometry (vtkRenderer *renderer)
| Call UpdateLightGeometry() on Renderer. More...
void | UpdateLights (vtkRenderer *renderer)
| Call UpdateLights() on Renderer. More...
void | UpdateGeometry (vtkRenderer *renderer, vtkFrameBufferObjectBase *fbo=nullptr)
| Call UpdateGeometry() on Renderer. More...
void | SetLastRenderingUsedDepthPeeling (vtkRenderer *renderer, bool value)
| Modify protected member LastRenderingUsedDepthPeeling on Renderer. More...
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Protected Attributes
vtkTextureObject * | ColorTexture = nullptr
vtkTextureObject * | PositionTexture = nullptr
vtkTextureObject * | NormalTexture = nullptr
vtkTextureObject * | SSAOTexture = nullptr
vtkTextureObject * | DepthTexture = nullptr
vtkOpenGLFramebufferObject * | FrameBufferObject = nullptr
vtkOpenGLQuadHelper * | SSAOQuadHelper = nullptr
vtkOpenGLQuadHelper * | CombineQuadHelper = nullptr
std::vector< float > | Kernel
unsigned int | KernelSize = 32
double | Radius = 0.5
double | Bias = 0.01
bool | Blur = false
Protected Attributes inherited from vtkImageProcessingPass
vtkRenderPass * | DelegatePass
Protected Attributes inherited from vtkOpenGLRenderPass
unsigned int | ActiveDrawBuffers = 0
Protected Attributes inherited from vtkRenderPass
int | NumberOfRenderedProps
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers

## Additional Inherited Members
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()

## Detailed Description

Implement a screen-space ambient occlusion pass.

SSAO darkens some pixels to improve depth perception simulating ambient occlusion in screen space. For each fragment, random samples inside a hemisphere at the fragment position oriented with the normal are tested against other fragments to compute an average occlusion. The number of samples and the radius of the hemisphere are configurables.

See also
  vtkRenderPass

Tests:
  vtkSSAOPass (Tests)

Definition at line 34 of file vtkSSAOPass.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkImageProcessingPass vtkSSAOPass::Superclass

Definition at line 38 of file vtkSSAOPass.h.

## Constructor & Destructor Documentation

## ◆ vtkSSAOPass()

vtkSSAOPass::vtkSSAOPass | ( |  | ) |
| protecteddefault

## ◆ ~vtkSSAOPass()

vtkSSAOPass::~vtkSSAOPass | ( |  | ) |
| overrideprotecteddefault

## Member Function Documentation

## ◆ New()

static vtkSSAOPass* vtkSSAOPass::New | ( |  | ) |
| static

## ◆ IsTypeOf()

static vtkTypeBool vtkSSAOPass::IsTypeOf | ( | const char * | type | ) |
| static

## ◆ IsA()

virtual vtkTypeBool vtkSSAOPass::IsA | ( | const char * | name | ) |
| virtual

Return 1 if this class is the same type of (or a subclass of) the named class.

Returns 0 otherwise. This method works in combination with vtkTypeMacro found in vtkSetGet.h.

Reimplemented from vtkImageProcessingPass.

## ◆ SafeDownCast()

static vtkSSAOPass* vtkSSAOPass::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkSSAOPass::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

Reimplemented from vtkImageProcessingPass.

## ◆ NewInstance()

vtkSSAOPass* vtkSSAOPass::NewInstance | ( |  | ) | const

## ◆ PrintSelf()

void vtkSSAOPass::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Methods invoked by print to print information about the object including superclasses.

Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes.

Reimplemented from vtkImageProcessingPass.

## ◆ Render()

void vtkSSAOPass::Render | ( | const vtkRenderState * | s | ) |
| overridevirtual

Perform rendering according to a render state.

Implements vtkRenderPass.

## ◆ ReleaseGraphicsResources()

void vtkSSAOPass::ReleaseGraphicsResources | ( | vtkWindow * | w | ) |
| overridevirtual

Release graphics resources and ask components to release their own resources.

Reimplemented from vtkImageProcessingPass.

## ◆ PreReplaceShaderValues()

bool vtkSSAOPass::PreReplaceShaderValues | ( | std::string & | vertexShader,
|  | std::string & | geometryShader,
|  | std::string & | fragmentShader,
|  | vtkAbstractMapper * | mapper,
|  | vtkProp * | prop
| ) |  |
| overridevirtual

Pre replace shader values.

Reimplemented from vtkOpenGLRenderPass.

## ◆ PostReplaceShaderValues()

bool vtkSSAOPass::PostReplaceShaderValues | ( | std::string & | vertexShader,
|  | std::string & | geometryShader,
|  | std::string & | fragmentShader,
|  | vtkAbstractMapper * | mapper,
|  | vtkProp * | prop
| ) |  |
| overridevirtual

Post replace shader values.

Reimplemented from vtkOpenGLRenderPass.

## ◆ SetShaderParameters()

bool vtkSSAOPass::SetShaderParameters | ( | vtkShaderProgram * | program,
|  | vtkAbstractMapper * | mapper,
|  | vtkProp * | prop,
|  | vtkOpenGLVertexArrayObject * | VAO = `nullptr`
| ) |  |
| overridevirtual

Set shader parameters.

Set the draw buffers depending on the mapper.

Reimplemented from vtkOpenGLRenderPass.

## ◆ GetRadius()

virtual double vtkSSAOPass::GetRadius | ( |  | ) |
| virtual

Get/Set the SSAO hemisphere radius.

Default is 0.5

## ◆ SetRadius()

virtual void vtkSSAOPass::SetRadius | ( | double |  | ) |
| virtual

Get/Set the SSAO hemisphere radius.

Default is 0.5

## ◆ GetKernelSize()

virtual unsigned int vtkSSAOPass::GetKernelSize | ( |  | ) |
| virtual

Get/Set the number of samples.

Default is 32

## ◆ SetKernelSize()

virtual void vtkSSAOPass::SetKernelSize | ( | unsigned int |  | ) |
| virtual

Get/Set the number of samples.

Default is 32

## ◆ GetBias()

virtual double vtkSSAOPass::GetBias | ( |  | ) |
| virtual

Get/Set the bias when comparing samples.

Default is 0.01

## ◆ SetBias()

virtual void vtkSSAOPass::SetBias | ( | double |  | ) |
| virtual

Get/Set the bias when comparing samples.

Default is 0.01

## ◆ GetBlur()

virtual bool vtkSSAOPass::GetBlur | ( |  | ) |
| virtual

Get/Set blurring of the ambient occlusion.

Blurring can help to improve the result if samples number is low. Default is false

## ◆ SetBlur()

virtual void vtkSSAOPass::SetBlur | ( | bool |  | ) |
| virtual

Get/Set blurring of the ambient occlusion.

Blurring can help to improve the result if samples number is low. Default is false

## ◆ BlurOn()

virtual void vtkSSAOPass::BlurOn | ( |  | ) |
| virtual

Get/Set blurring of the ambient occlusion.

Blurring can help to improve the result if samples number is low. Default is false

## ◆ BlurOff()

virtual void vtkSSAOPass::BlurOff | ( |  | ) |
| virtual

Get/Set blurring of the ambient occlusion.

Blurring can help to improve the result if samples number is low. Default is false

## ◆ ComputeKernel()

void vtkSSAOPass::ComputeKernel | ( |  | ) |
| protected

## ◆ InitializeGraphicsResources()

void vtkSSAOPass::InitializeGraphicsResources | ( | vtkOpenGLRenderWindow * | renWin,
|  | int | w,
|  | int | h
| ) |  |
| protected

## ◆ RenderDelegate()

void vtkSSAOPass::RenderDelegate | ( | const vtkRenderState * | s,
|  | int | w,
|  | int | h
| ) |  |
| protected

## ◆ RenderSSAO()

void vtkSSAOPass::RenderSSAO | ( | vtkOpenGLRenderWindow * | renWin,
|  | vtkMatrix4x4 * | projection,
|  | int | w,
|  | int | h
| ) |  |
| protected

## ◆ RenderCombine()

void vtkSSAOPass::RenderCombine | ( | vtkOpenGLRenderWindow * | renWin | ) |
| protected

## Member Data Documentation

## ◆ ColorTexture

vtkTextureObject* vtkSSAOPass::ColorTexture = nullptr
| protected

Definition at line 118 of file vtkSSAOPass.h.

## ◆ PositionTexture

vtkTextureObject* vtkSSAOPass::PositionTexture = nullptr
| protected

Definition at line 119 of file vtkSSAOPass.h.

## ◆ NormalTexture

vtkTextureObject* vtkSSAOPass::NormalTexture = nullptr
| protected

Definition at line 120 of file vtkSSAOPass.h.

## ◆ SSAOTexture

vtkTextureObject* vtkSSAOPass::SSAOTexture = nullptr
| protected

Definition at line 121 of file vtkSSAOPass.h.

## ◆ DepthTexture

vtkTextureObject* vtkSSAOPass::DepthTexture = nullptr
| protected

Definition at line 122 of file vtkSSAOPass.h.

## ◆ FrameBufferObject

vtkOpenGLFramebufferObject* vtkSSAOPass::FrameBufferObject = nullptr
| protected

Definition at line 124 of file vtkSSAOPass.h.

## ◆ SSAOQuadHelper

vtkOpenGLQuadHelper* vtkSSAOPass::SSAOQuadHelper = nullptr
| protected

Definition at line 126 of file vtkSSAOPass.h.

## ◆ CombineQuadHelper

vtkOpenGLQuadHelper* vtkSSAOPass::CombineQuadHelper = nullptr
| protected

Definition at line 127 of file vtkSSAOPass.h.

## ◆ Kernel

std::vector<float> vtkSSAOPass::Kernel
| protected

Definition at line 129 of file vtkSSAOPass.h.

## ◆ KernelSize

unsigned int vtkSSAOPass::KernelSize = 32
| protected

Definition at line 130 of file vtkSSAOPass.h.

## ◆ Radius

double vtkSSAOPass::Radius = 0.5
| protected

Definition at line 131 of file vtkSSAOPass.h.

## ◆ Bias

double vtkSSAOPass::Bias = 0.01
| protected

Definition at line 132 of file vtkSSAOPass.h.

## ◆ Blur

bool vtkSSAOPass::Blur = false
| protected

Definition at line 133 of file vtkSSAOPass.h.

The documentation for this class was generated from the following file:

- Rendering/OpenGL2/vtkSSAOPass.h